//---------------------------------------------------------------------------
//
//   MQBasePlugin
//
//          Copyright(C) 2000-2008, O.Mizno
//
//    @MetasequoiapvOCC^[tF[XAPIxB
//    C++̃NXƂĈ߂̃bp[łB
//      evOC̎ނƂɕK{API͏z֐ƂĒ`
//    Ă邽߁Å֐͌pNXŎsKv܂B
//
//---------------------------------------------------------------------------

#include "PreCompiled.h"
//#include <windows.h>
//#include <stdio.h>
#include "MQPlugin.h"
#include "MQBasePlugin.h"
#include "MQSetting.h"


static void *ExtractEventOption(void *option, const char *name);
static BOOL ExtractEventOptionBool(void *option, const char *name, BOOL defval);
static int ExtractEventOptionInt(void *option, const char *name, int defval);
static float ExtractEventOptionFloat(void *option, const char *name, float defval);

//---------------------------------------------------------------------------
//  MQGetPlugInID
//    vOCIDԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT void MQGetPlugInID(DWORD *Product, DWORD *ID)
{
	// v_Ng(Җ)IDAS64bit̒lƂĕԂ
	// l͑ƏdȂ悤ȃ_Ȃ̂ŗǂ
	GetPluginClass()->GetPlugInID(Product, ID);
}

//---------------------------------------------------------------------------
//  MQGetPlugInName
//    vOCԂB
//    ̊֐[vOCɂ]\ɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT const char *MQGetPlugInName(void)
{
	// vOC	
	return GetPluginClass()->GetPlugInName();
}

//---------------------------------------------------------------------------
//  MQGetPlugInType
//    vOC̃^CvԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT int MQGetPlugInType(void)
{
	return GetPluginClass()->GetPlugInType();
}

//---------------------------------------------------------------------------
//  MQEnumString
//    |bvAbvj[܂̓{^ɕ\镶ԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT const char *MQEnumString(int index)
{
	MQBasePlugin *plugin = GetPluginClass();
	switch(plugin->GetPlugInType()){
	case MQPLUGIN_TYPE_OBJECT:
	case MQPLUGIN_TYPE_SELECT:
	case MQPLUGIN_TYPE_CREATE:
		return static_cast<MQMenuBasePlugin*>(plugin)->EnumString(index);
	case MQPLUGIN_TYPE_STATION:
	case MQPLUGIN_TYPE_COMMAND:
		if (index == 0)
			return static_cast<MQStationPlugin*>(plugin)->EnumString();
		break;
	}
	return NULL;
}

//---------------------------------------------------------------------------
//  MQEnumFileType
//    ͂܂͏o͉\ȃt@C^CvԂB
//    t@C^Cv͕ʖۑ̃_CAOɕ\B
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT const char *MQEnumFileType(int index)
{
	MQBasePlugin *plugin = GetPluginClass();
	switch(plugin->GetPlugInType()){
	case MQPLUGIN_TYPE_IMPORT:
		return static_cast<MQImportPlugin*>(plugin)->EnumFileType(index);
	case MQPLUGIN_TYPE_EXPORT:
		return static_cast<MQExportPlugin*>(plugin)->EnumFileType(index);
	}
	return NULL;
}

//---------------------------------------------------------------------------
//  MQEnumFileExt
//    ͂܂͏o͉\ȊgqԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT const char *MQEnumFileExt(int index)
{
	MQBasePlugin *plugin = GetPluginClass();
	switch(plugin->GetPlugInType()){
	case MQPLUGIN_TYPE_IMPORT:
		return static_cast<MQImportPlugin*>(plugin)->EnumFileExt(index);
	case MQPLUGIN_TYPE_EXPORT:
		return static_cast<MQExportPlugin*>(plugin)->EnumFileExt(index);
	}
	return NULL;
}

//---------------------------------------------------------------------------
//  MQImportFile
//    [ǂݍ]hbOhbvœǂݍނƂɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT BOOL MQImportFile(int index, const char *filename, MQDocument doc)
{
	return static_cast<MQImportPlugin*>(GetPluginClass())->ImportFile(index, filename, doc);
}

//---------------------------------------------------------------------------
//  MQExportFile
//    [ʖŕۑ]ŕۑƂɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT BOOL MQExportFile(int index, const char *filename, MQDocument doc)
{
	return static_cast<MQExportPlugin*>(GetPluginClass())->ExportFile(index, filename, doc);
}

//---------------------------------------------------------------------------
//  MQCreate
//    j[IꂽƂɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT BOOL MQCreate(int index, MQDocument doc)
{
	return static_cast<MQCreatePlugin*>(GetPluginClass())->Execute(index, doc);
}

//---------------------------------------------------------------------------
//  MQModifySelect
//    j[IꂽƂɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT BOOL MQModifySelect(int index, MQDocument doc)
{
	return static_cast<MQSelectPlugin*>(GetPluginClass())->Execute(index, doc);
}

//---------------------------------------------------------------------------
//  MQModifyObject
//    j[IꂽƂɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT BOOL MQModifyObject(int index, MQDocument doc)
{
	return static_cast<MQObjectPlugin*>(GetPluginClass())->Execute(index, doc);
}

//---------------------------------------------------------------------------
//  MQOnEvent
//    CxgɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT BOOL MQOnEvent(MQDocument doc, int event_type, void *option)
{
	MQStationPlugin *plugin = static_cast<MQStationPlugin*>(GetPluginClass());

	switch(event_type){
	case MQEVENT_INITIALIZE:	// vOC̏
		return plugin->Initialize();

	case MQEVENT_EXIT:			// vOC̏I
		plugin->Exit();
		return TRUE;

	case MQEVENT_ACTIVATE:		// \E\؂ւv
		{
			BOOL flag = *(BOOL *)option;
			return plugin->Activate(doc, flag);
		}

	case MQEVENT_IS_ACTIVATED:	// \E\Ԃ̕ԓ
		return plugin->IsActivated(doc);

	case MQEVENT_MINIMIZE:		// EChE̍ŏ
		{
			BOOL flag = *(BOOL *)option;
			plugin->OnMinimize(doc, flag);
			return TRUE;
		}

	case MQEVENT_USER_MESSAGE:	// vOCƎ̃bZ[W
		{
			DWORD product = (DWORD)ExtractEventOptionInt(option, "src_product", 0);
			DWORD id = (DWORD)ExtractEventOptionInt(option, "src_id", 0);
			const char *description = (const char *)ExtractEventOption(option, "description");
			void *message = ExtractEventOption(option, "message");
			int *result = (int*)ExtractEventOption(option, "result");
			int ret = plugin->OnReceiveUserMessage(doc, product, id, description, message);
			if (result != NULL) *result = ret;
			return TRUE;
		}

	case MQEVENT_DRAW:	// `掞̏
		{
			MQScene scene = (MQScene)ExtractEventOption(option, "scene");
			int width = ExtractEventOptionInt(option, "width", 1);
			int height = ExtractEventOptionInt(option, "height", 1);
			plugin->OnDraw(doc, scene, width, height);
			return TRUE;
		}

	case MQEVENT_LBUTTON_DOWN:	// {^ꂽƂ
	case MQEVENT_LBUTTON_MOVE:	// {^Ȃ}EXړƂ
	case MQEVENT_LBUTTON_UP:	// {^ꂽƂ
	case MQEVENT_MBUTTON_DOWN:	// {^ꂽƂ
	case MQEVENT_MBUTTON_MOVE:	// {^Ȃ}EXړƂ
	case MQEVENT_MBUTTON_UP:	// {^ꂽƂ
	case MQEVENT_RBUTTON_DOWN:	// E{^ꂽƂ
	case MQEVENT_RBUTTON_MOVE:	// E{^Ȃ}EXړƂ
	case MQEVENT_RBUTTON_UP:	// E{^ꂽƂ
	case MQEVENT_MOUSE_MOVE:	// }EXړƂ
	case MQEVENT_MOUSE_WHEEL:	// }EX̃zC[]Ƃ
		{
			MQCommandPlugin *com_plugin = dynamic_cast<MQCommandPlugin*>(plugin);
			if (com_plugin == NULL)
				return FALSE;

			MQScene scene = (MQScene)ExtractEventOption(option, "scene");
			DWORD button_state = (DWORD)ExtractEventOptionInt(option, "button_state", 0);
			MQCommandPlugin::MOUSE_BUTTON_STATE button;
			button.MousePos.x = ExtractEventOptionInt(option, "mouse_pos_x", 0);
			button.MousePos.y = ExtractEventOptionInt(option, "mouse_pos_y", 0);
			button.Wheel = ExtractEventOptionInt(option, "mouse_wheel", 0);
			button.LButton = (button_state & MK_LBUTTON) ? TRUE : FALSE;
			button.MButton = (button_state & MK_MBUTTON) ? TRUE : FALSE;
			button.RButton = (button_state & MK_RBUTTON) ? TRUE : FALSE;
			button.Shift = (button_state & MK_SHIFT) ? TRUE : FALSE;
			button.Ctrl = (button_state & MK_CONTROL) ? TRUE : FALSE;
			button.Alt = (button_state & MK_ALT) ? TRUE : FALSE;
			switch(event_type){
			case MQEVENT_LBUTTON_DOWN:	// {^ꂽƂ
				return com_plugin->OnLeftButtonDown(doc, scene, button);
			case MQEVENT_LBUTTON_MOVE:	// {^Ȃ}EXړƂ
				return com_plugin->OnLeftButtonMove(doc, scene, button);
			case MQEVENT_LBUTTON_UP:	// {^ꂽƂ
				return com_plugin->OnLeftButtonUp(doc, scene, button);
			case MQEVENT_MBUTTON_DOWN:	// {^ꂽƂ
				return com_plugin->OnMiddleButtonDown(doc, scene, button);
			case MQEVENT_MBUTTON_MOVE:	// {^Ȃ}EXړƂ
				return com_plugin->OnMiddleButtonMove(doc, scene, button);
			case MQEVENT_MBUTTON_UP:	// {^ꂽƂ
				return com_plugin->OnMiddleButtonUp(doc, scene, button);
			case MQEVENT_RBUTTON_DOWN:	// E{^ꂽƂ
				return com_plugin->OnRightButtonDown(doc, scene, button);
			case MQEVENT_RBUTTON_MOVE:	// E{^Ȃ}EXړƂ
				return com_plugin->OnRightButtonMove(doc, scene, button);
			case MQEVENT_RBUTTON_UP:	// E{^ꂽƂ
				return com_plugin->OnRightButtonUp(doc, scene, button);
			case MQEVENT_MOUSE_MOVE:	// }EXړƂ
				return com_plugin->OnMouseMove(doc, scene, button);
			case MQEVENT_MOUSE_WHEEL:	// }EX̃zC[]Ƃ
				return com_plugin->OnMouseWheel(doc, scene, button);
			}
			return FALSE;
		}

	case MQEVENT_KEY_DOWN:		// L[ꂽƂ
	case MQEVENT_KEY_UP:		// L[ꂽƂ
		{
			MQCommandPlugin *com_plugin = dynamic_cast<MQCommandPlugin*>(plugin);
			if (com_plugin == NULL)
				return FALSE;

			MQScene scene = (MQScene)ExtractEventOption(option, "scene");
			int key = ExtractEventOptionInt(option, "key", 0);
			DWORD button_state = (DWORD)ExtractEventOptionInt(option, "button_state", 0);
			MQCommandPlugin::MOUSE_BUTTON_STATE button;
			button.MousePos.x = 0;
			button.MousePos.y = 0;
			button.Wheel = 0;
			button.LButton = (button_state & MK_LBUTTON) ? TRUE : FALSE;
			button.MButton = (button_state & MK_MBUTTON) ? TRUE : FALSE;
			button.RButton = (button_state & MK_RBUTTON) ? TRUE : FALSE;
			button.Shift = (button_state & MK_SHIFT) ? TRUE : FALSE;
			button.Ctrl = (button_state & MK_CONTROL) ? TRUE : FALSE;
			button.Alt = (button_state & MK_ALT) ? TRUE : FALSE;
			switch(event_type){
			case MQEVENT_KEY_DOWN:		// L[ꂽƂ
				return com_plugin->OnKeyDown(doc, scene, key, button);
			case MQEVENT_KEY_UP:		// L[ꂽƂ
				return com_plugin->OnKeyUp(doc, scene, key, button);
			}
			return FALSE;
		}

	case MQEVENT_NEW_DOCUMENT:	// hLg
		{
			MQStationPlugin::NEW_DOCUMENT_PARAM param;
			//param.root = (MQXmlElement)ExtractEventOption(option, "root_elem"); // APIƂĒ񋟂Ȃ{͗p
			param.elem = (MQXmlElement)ExtractEventOption(option, "xml_elem");
			plugin->OnNewDocument(doc, (const char *)ExtractEventOption(option, "filename"), param);
		}
		return TRUE;

	case MQEVENT_END_DOCUMENT:	// hLgI
		plugin->OnEndDocument(doc);
		return TRUE;

	case MQEVENT_SAVE_DOCUMENT:	// hLgۑ
		{
			MQStationPlugin::SAVE_DOCUMENT_PARAM param;
			//param.root = (MQXmlElement)ExtractEventOption(option, "root_elem"); // APIƂĒ񋟂Ȃ{͗p
			param.elem = (MQXmlElement)ExtractEventOption(option, "xml_elem");
			param.bSaveUniqueID = FALSE;
			plugin->OnSaveDocument(doc, (const char *)ExtractEventOption(option, "filename"), param);
			if (param.bSaveUniqueID){
				BOOL *save_uid = (BOOL*)ExtractEventOption(option, "save_uid");
				if (save_uid != NULL)
					*save_uid = TRUE;
			}
		}
		return TRUE;

	case MQEVENT_UNDO:	// AhDs
		return plugin->OnUndo(doc, ExtractEventOptionInt(option, "state", 0));

	case MQEVENT_REDO:	// hDs
		return plugin->OnRedo(doc, ExtractEventOptionInt(option, "state", 0));

	case MQEVENT_UNDO_UPDATED:	// AhDԍXV
		plugin->OnUpdateUndo(doc, ExtractEventOptionInt(option, "state", 0), ExtractEventOptionInt(option, "size", 0));
		return TRUE;

	case MQEVENT_OBJECT_MODIFIED:	// IuWFNg̕ҏW
		plugin->OnObjectModified(doc);
		return TRUE;

	case MQEVENT_OBJECT_SELECTED:	// IuWFNg̑IԂ̕ύX
		plugin->OnObjectSelected(doc);
		return TRUE;

	case MQEVENT_OBJECT_LIST:		// JgIuWFNg̕ύX
		plugin->OnUpdateObjectList(doc);
		return TRUE;

	case MQEVENT_MATERIAL_MODIFIED:	// }eÃp[^ύX
		plugin->OnMaterialModified(doc);
		return TRUE;

	case MQEVENT_MATERIAL_LIST:		// Jg}eA̕ύX
		plugin->OnUpdateMaterialList(doc);
		return TRUE;

	case MQEVENT_SCENE:	// V[̕ύX
		{
			MQScene scene = (MQScene)ExtractEventOption(option, "scene");
			plugin->OnUpdateScene(doc, scene);
			return TRUE;
		}

	default:
		break;
	}

	return FALSE;
}


void *ExtractEventOption(void *option, const char *name)
{
	if (option != NULL){
		void **array = (void**)option;
		for (int i=0; array[i]!=NULL; i+=2){
			if (strcmp((char*)array[i], name) == 0)
				return array[i+1];
		}
	}
	return NULL;
}

BOOL ExtractEventOptionBool(void *option, const char *name, BOOL defval)
{
	BOOL *ptr = (BOOL*)ExtractEventOption(option, name);
	return (ptr != NULL) ? *ptr : defval;
}

int ExtractEventOptionInt(void *option, const char *name, int defval)
{
	int *ptr = (int*)ExtractEventOption(option, name);
	return (ptr != NULL) ? *ptr : defval;
}

float ExtractEventOptionFloat(void *option, const char *name, float defval)
{
	float *ptr = (float*)ExtractEventOption(option, name);
	return (ptr != NULL) ? *ptr : defval;
}


//---------------------------------------------------------------------------
//
//  class MQBasePlugin
//    ׂĂ̌^̃vOC̊NX
//
//---------------------------------------------------------------------------

// RXgN^
MQBasePlugin::MQBasePlugin()
{
}

// fXgN^
MQBasePlugin::~MQBasePlugin()
{
}

// ݒt@CJ
MQSetting *MQBasePlugin::OpenSetting(void)
{
	DWORD Product, ID;
	char path[MAX_PATH];
	char section[64];

	// ݒinit@C擾
	if (!MQ_GetSystemPath(path, MQFOLDER_METASEQ_INI))
		return NULL;

	// ZNV
	GetPlugInID(&Product, &ID);
	sprintf_s(section, "Plugin.%08X:%08X", Product, ID);

	// MQSetting𐶐ĕԂ
	return new MQSetting(path, section);
}

// ݒt@C
void MQBasePlugin::CloseSetting(MQSetting *setting)
{
	delete setting;
}


//---------------------------------------------------------------------------
//  MQStationPlugin::SendUserMessage
//    ̏풓^i܂̓R}hjvOCɔCӂ̃bZ[W𑗂܂B
//    vOCɓnf[^͔Cӂ̂̂messageɃ|C^Ƃė^
//    Ƃł܂B
//    target_producttarget_id0w肷ƁAׂẴvOCɒʒm܂B
//
//    target_product	- ovOC̃v_NgID
//    target_id			- ovOC̃vOCID
//    description		- bZ[W̎ނCӂ̕
//    message			- Cӂ̃bZ[W
//    ߂l			- vOCԂꂽl
//---------------------------------------------------------------------------
int MQBasePlugin::SendUserMessage(MQDocument doc, DWORD target_product, DWORD target_id, const char *description, void *message)
{
	MQSendMessageInfo info;
	void *array[13];
	int result = 0;

	array[0] = "document";
	array[1] = doc;
	array[2] = "target_product";
	array[3] = &target_product;
	array[4] = "target_id";
	array[5] = &target_id;
	array[6] = "description";
	array[7] = (void*)description;
	array[8] = "message";
	array[9] = message;
	array[10] = "result";
	array[11] = &result;
	array[12] = NULL;

	GetPlugInID(&info.Product, &info.ID);
	info.option = array;

	MQ_SendMessage(MQMESSAGE_USER_MESSAGE, &info);

	return result;
}


//---------------------------------------------------------------------------
//
//  class MQStationPlugin
//    풓^vOCp̃x[XNX
//
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//  MQStationPlugin::MQStationPlugin
//    RXgN^
//---------------------------------------------------------------------------
MQStationPlugin::MQStationPlugin()
{
}

//---------------------------------------------------------------------------
//  MQStationPlugin::OnMinimize
//    EChE̍ŏւ̕ԓ
//---------------------------------------------------------------------------
void MQStationPlugin::OnMinimize(MQDocument doc, BOOL flag)
{
}

//---------------------------------------------------------------------------
//  MQStationPlugin::OnReceiveUserMessage
//    MQBasePlugin::SendUserMessage()ő̃vOC烁bZ[W
//    oꂽɌĂяo܂B
//    doc           - hLg
//    src_product	- ovOC̃v_NgID
//    src_id		- ovOC̃vOCID
//    description	- bZ[W̓e\Cӂ̕
//    message		- bZ[W̓e
//    ߂l        - ovOCɕԂCӂ̒l
//---------------------------------------------------------------------------
int MQStationPlugin::OnReceiveUserMessage(MQDocument doc, DWORD src_product, DWORD src_id, const char *description, void *message)
{
	return 0;
}


//---------------------------------------------------------------------------
//  MQStationPlugin::OnDraw
//    `掞ɌĂяo܂B
//---------------------------------------------------------------------------
void MQStationPlugin::OnDraw(MQDocument doc, MQScene scene, int width, int height)
{
}

//---------------------------------------------------------------------------
//  MQStationPlugin::OnNewDocument
//    hLgɌĂяo܂B
//    filename - [NULLȊO] MQOt@Cǂݍ܂ꂽꍇ̃t@C
//               [NULL] VKhLgƂĐꂽ
//    param.elem - [NULLȊO] t@CۑɕtꂽXMLvf
//                 [NULL] VKhLgƂĐꂽA܂XMLvf
//                        ۑĂȂB
//---------------------------------------------------------------------------
void MQStationPlugin::OnNewDocument(MQDocument doc, const char *filename, NEW_DOCUMENT_PARAM& param)
{
}

//---------------------------------------------------------------------------
//  MQStationPlugin::OnEndDocument
//    hLgIɌĂяo܂B
//---------------------------------------------------------------------------
void MQStationPlugin::OnEndDocument(MQDocument doc)
{
}

//---------------------------------------------------------------------------
//  MQStationPlugin::OnSaveDocument
//    MQOt@CۑOɌĂяo܂B
//    param.elem̓vOCƎ̏ۑ邽߂XMLvfŁA̗vf
//    qvft邱Ƃł܂B
//---------------------------------------------------------------------------
void MQStationPlugin::OnSaveDocument(MQDocument doc, const char *filename, SAVE_DOCUMENT_PARAM& param)
{
}

//---------------------------------------------------------------------------
//  MQStationPlugin::OnUndo
//    AhDsɌĂяo܂B
//    ߂l̓vOCƎ̃AhDsꍇTRUEԂ܂A
//    @iKł͓ȏF߂Ă炸AFALSEԂKv܂B
//---------------------------------------------------------------------------
BOOL MQStationPlugin::OnUndo(MQDocument doc, int undo_state)
{
	// ʂȃAhDsȂ̂FALSEԂ
	return FALSE;
}

//---------------------------------------------------------------------------
//  MQStationPlugin::OnRedo
//    hDsɌĂяo܂B
//    ߂l̓vOCƎ̃AhDsꍇTRUEԂ܂A
//    @iKł͓ȏF߂Ă炸AFALSEԂKv܂B
//---------------------------------------------------------------------------
BOOL MQStationPlugin::OnRedo(MQDocument doc, int redo_state)
{
	// ʂȃhDsȂ̂FALSEԂ
	return FALSE;
}

//---------------------------------------------------------------------------
//  MQStationPlugin::OnUpdateUndo
//    AhD̏ԂXVꂽƂɌĂяo܂B
//    ̊֐ł̓IuWFNg̓eXɕύXĂ͂܂B
//    undo_state - AhD̏ԃJE^
//    undo_size  - AhD̎s\
//---------------------------------------------------------------------------
void MQStationPlugin::OnUpdateUndo(MQDocument doc, int undo_state, int undo_size)
{
}

//---------------------------------------------------------------------------
//  MQStationPlugin::OnObjectModified
//    IuWFNgҏWꂽɌĂяo܂B
//    ̊֐ł̓IuWFNg̓eXɕύXĂ͂܂B
//    AhDXVOɌĂяo܂B
//---------------------------------------------------------------------------
void MQStationPlugin::OnObjectModified(MQDocument doc)
{
}

//---------------------------------------------------------------------------
//  MQStationPlugin::OnObjectSelected
//    IuWFNg̒_EӁEʁEUVIꂽɌĂяo܂B
//    ̊֐ł̓IuWFNg̓eEIԂXɕύXĂ͂܂B
//    AhDXVOɌĂяo܂B
//---------------------------------------------------------------------------
void MQStationPlugin::OnObjectSelected(MQDocument doc)
{
}

//---------------------------------------------------------------------------
//  MQStationPlugin::OnUpdateObjectList
//    JgIuWFNg̕ύXAIuWFNg̒ǉE폜sꂽ
//    Ăяo܂B
//    ̊֐ł̓IuWFNg̓eEIԂXɕύXĂ͂܂B
//    AhDXVOɌĂяo܂B
//---------------------------------------------------------------------------
void MQStationPlugin::OnUpdateObjectList(MQDocument doc)
{
}

//---------------------------------------------------------------------------
//  MQStationPlugin::OnMaterialModified
//    }eÃp[^ύXꂽɌĂяo܂B
//    ̊֐ł̓IuWFNgE}eA̓eXɕύXĂ͂܂B
//    AhDXVOɌĂяo܂B
//---------------------------------------------------------------------------
void MQStationPlugin::OnMaterialModified(MQDocument doc)
{
}

//---------------------------------------------------------------------------
//  MQStationPlugin::OnUpdateMaterialList
//    Jg}eA̕ύXA}eA̒ǉE폜sꂽ
//    Ăяo܂B
//    ̊֐ł̓}eA̓eXɕύXĂ͂܂B
//    AhDXVOɌĂяo܂B
//---------------------------------------------------------------------------
void MQStationPlugin::OnUpdateMaterialList(MQDocument doc)
{
}

//---------------------------------------------------------------------------
//  MQStationPlugin::OnMaterialModified
//    J̌Y[ȂǁAV[񂪕ύXꂽɌĂяo܂B
//    ̊֐ł̓V[XɕύXĂ͂܂B
//---------------------------------------------------------------------------
void MQStationPlugin::OnUpdateScene(MQDocument doc, MQScene scene)
{
}

//---------------------------------------------------------------------------
//  MQStationPlugin::WindowClose
//    vOCǗĂEChEꂽƂ
//    ̊֐ĂяoƁA{̑ɒʒmꃁj[
//    `FbNO悤ɂȂ܂B
//---------------------------------------------------------------------------
void MQStationPlugin::WindowClose()
{
	MQSendMessageInfo info;
	BOOL flag = FALSE;

	GetPlugInID(&info.Product, &info.ID);
	info.option = &flag;

	MQ_SendMessage(MQMESSAGE_ACTIVATE, &info);
}

//---------------------------------------------------------------------------
//  MQStationPlugin::BeginCallback
//    WindowsbZ[Wɑ΂鉞vOCŏꍇA
//    ̊֐ĂяoƕKvȏsꂽ
//    ExecuteCallback()ĂяoAMQDocumentɑ΂鏈
//    sƂł܂B
//---------------------------------------------------------------------------
void MQStationPlugin::BeginCallback(void *option)
{
	StationCallbackInnerOption inner;
	inner.this_ptr = this;
	inner.option = option;

	MQ_StationCallback(StationCallback, &inner);
}

//---------------------------------------------------------------------------
//  MQStationPlugin::StationCallback
//    BeginCallback()ĂяoɁAŌĂяostatic
//    R[obN֐łB
//    ̊֐͂ɏz֐ExecuteCallback()Ăяo܂B
//---------------------------------------------------------------------------
BOOL __stdcall MQStationPlugin::StationCallback(MQDocument doc, void *option)
{
	StationCallbackInnerOption *inner = (StationCallbackInnerOption*)option;
	return inner->this_ptr->ExecuteCallback(doc, inner->option) ? TRUE : FALSE;
}


//---------------------------------------------------------------------------
//  MQStationPlugin::CreateDrawingObject
//    OnDraw()ɕ`悷IuWFNgǉ܂B
//
//    MQObject::DeleteThis()ō폜Ă͂܂B
//    instantTRUEw肵č쐬ꂽIuWFNg͕`悪ƎI
//    j܂B
//    instantFALSEw肵č쐬IuWFNǵAsvɂȂ_
//    DeleteDrawingObject()ō폜ĂB܂AIuWFNgێ
//    ꂽ܂OnEndDocument()ĂяoꂽA̎_ō폜ĂB
//---------------------------------------------------------------------------
MQObject MQStationPlugin::CreateDrawingObject(MQDocument doc, DRAW_OBJECT_VISIBILITY visibility, BOOL instant)
{
	MQSendMessageInfo info;
	void *array[9];

	array[0] = "document";
	array[1] = doc;
	array[2] = "visibility";
	array[3] = &visibility;
	array[4] = "instant";
	array[5] = &instant;
	array[6] = "result";
	array[7] = NULL;
	array[8] = NULL;

	GetPlugInID(&info.Product, &info.ID);
	info.option = array;

	MQ_SendMessage(MQMESSAGE_NEW_DRAW_OBJECT, &info);

	return (MQObject)array[7];
}


//---------------------------------------------------------------------------
//  MQStationPlugin::CreateDrawingMaterial
//    OnDraw()CreateDrawingObject()ō쐬IuWFNg`Ɏgp
//    }eAǉ܂B
//    indexɂMQObject::SetFaceMaterial()Ɏw肷CfbNXԂ܂B
//
//    쐬ꂽ}eAMQMaterial::DeleteThis()ō폜Ă͂܂B
//    instantTRUEw肵č쐬ꂽ}eA͕`悪ƎI
//    j܂B
//    instantFALSEw肵č쐬}eÁAsvɂȂ_
//    DeleteDrawingMaterial()ō폜ĂB܂A}eAێ
//    ꂽ܂OnEndDocument()ĂяoꂽA̎_ō폜ĂB
//---------------------------------------------------------------------------
MQMaterial MQStationPlugin::CreateDrawingMaterial(MQDocument doc, int& index, BOOL instant)
{
	MQSendMessageInfo info;
	void *array[9];
	int i=-1;

	array[0] = "document";
	array[1] = doc;
	array[2] = "index";
	array[3] = &i;
	array[4] = "instant";
	array[5] = &instant;
	array[6] = "result";
	array[7] = NULL;
	array[8] = NULL;

	GetPlugInID(&info.Product, &info.ID);
	info.option = array;

	MQ_SendMessage(MQMESSAGE_NEW_DRAW_MATERIAL, &info);

	index = i;
	return (MQMaterial)array[7];
}


//---------------------------------------------------------------------------
//  MQStationPlugin::DeleteDrawingObject
//    CreateDrawingObject()instantFALSEɂč쐬IuWFNg폜
//    ܂B
//---------------------------------------------------------------------------
void MQStationPlugin::DeleteDrawingObject(MQDocument doc, MQObject obj)
{
	MQSendMessageInfo info;
	void *array[5];

	array[0] = "document";
	array[1] = doc;
	array[2] = "object";
	array[3] = obj;
	array[4] = NULL;

	GetPlugInID(&info.Product, &info.ID);
	info.option = array;

	MQ_SendMessage(MQMESSAGE_DELETE_DRAW_OBJECT, &info);
}


//---------------------------------------------------------------------------
//  MQStationPlugin::DeleteDrawingMaterial
//    CreateDrawingMaterial()instantFALSEɂč쐬}eA폜
//    ܂B
//---------------------------------------------------------------------------
void MQStationPlugin::DeleteDrawingMaterial(MQDocument doc, MQMaterial mat)
{
	MQSendMessageInfo info;
	void *array[5];

	array[0] = "document";
	array[1] = doc;
	array[2] = "material";
	array[3] = mat;
	array[4] = NULL;

	GetPlugInID(&info.Product, &info.ID);
	info.option = array;

	MQ_SendMessage(MQMESSAGE_DELETE_DRAW_MATERIAL, &info);
}


//---------------------------------------------------------------------------
//  MQStationPlugin::GetCurrentUndoState
//    ݂̃AhD̏ԃJE^擾܂B
//---------------------------------------------------------------------------
int MQStationPlugin::GetCurrentUndoState(MQDocument doc)
{
	MQSendMessageInfo info;
	void *array[5];
	int state=-1;

	array[0] = "document";
	array[1] = doc;
	array[2] = "result";
	array[3] = &state;
	array[4] = NULL;

	GetPlugInID(&info.Product, &info.ID);
	info.option = array;

	MQ_SendMessage(MQMESSAGE_GET_UNDO_STATE, &info);

	return state;
}

//---------------------------------------------------------------------------
//  MQStationPlugin::GetSceneOption
//    V[̕\IvV擾
//---------------------------------------------------------------------------
void MQStationPlugin::GetSceneOption(MQScene scene, SCENE_OPTION& option)
{
	MQSendMessageInfo info;
	void *array[13];

	memset(&option, 0, sizeof(SCENE_OPTION));
	
	array[0] = "scene";
	array[1] = scene;
	array[2] = "show_vertex";
	array[3] = &option.ShowVertex;
	array[4] = "show_line";
	array[5] = &option.ShowLine;
	array[6] = "show_face";
	array[7] = &option.ShowFace;
	array[8] = "front_only";
	array[9] = &option.FrontOnly;
	array[10] = "show_bkimg";
	array[11] = &option.ShowBkimg;
	array[12] = NULL;

	GetPlugInID(&info.Product, &info.ID);
	info.option = array;

	MQ_SendMessage(MQMESSAGE_GET_SCENE_OPTION, &info);
}




//---------------------------------------------------------------------------
//
//  class MQCommandPlugin
//    R}hvOCp̃x[XNX
//
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//  MQCommandPlugin::MQCommandPlugin
//    RXgN^
//---------------------------------------------------------------------------
MQCommandPlugin::MQCommandPlugin()
{
}

//---------------------------------------------------------------------------
//  MQCommandPlugin::IsActivated
//    \E\Ԃ̕ԓ
//---------------------------------------------------------------------------
BOOL MQCommandPlugin::IsActivated(MQDocument doc)
{
	// R}hvOCłIsActivated()͕KKv
	// Ȃ̂ŁAWƂTRUEԂ
	return TRUE;
}

//---------------------------------------------------------------------------
//  MQCommandPlugin::ExecuteCallback
//    R[obNɑ΂
//---------------------------------------------------------------------------
bool MQCommandPlugin::ExecuteCallback(MQDocument doc, void *option)
{
	// R}hvOCłExecuteCallback()͕KKv
	// Ȃ̂ŁAWƂtrueԂ
	return true;
}

//---------------------------------------------------------------------------
//  MQCommandPlugin::OnLeftButtonDown
//    {^ꂽƂɌĂяo܂B
//    vOCƎ̓sꍇɂTRUEAƎs킸
//    Ws킹ꍇɂFALSE߂lƂĕԂ܂B
//---------------------------------------------------------------------------
BOOL MQCommandPlugin::OnLeftButtonDown(MQDocument doc, MQScene scene, MOUSE_BUTTON_STATE& state)
{
	// vOCƎ̓sTRUEԂ
	return TRUE;
}

//---------------------------------------------------------------------------
//  MQCommandPlugin::OnLeftButtonMove
//    {^Ȃ}EXړƂɌĂяo܂B
//---------------------------------------------------------------------------
BOOL MQCommandPlugin::OnLeftButtonMove(MQDocument doc, MQScene scene, MOUSE_BUTTON_STATE& state)
{
	// vOCƎ̓sTRUEԂ
	return TRUE;
}

//---------------------------------------------------------------------------
//  MQCommandPlugin::OnLeftButtonUp
//    {^ꂽƂɌĂяo܂B
//---------------------------------------------------------------------------
BOOL MQCommandPlugin::OnLeftButtonUp(MQDocument doc, MQScene scene, MOUSE_BUTTON_STATE& state)
{
	// vOCƎ̓sTRUEԂ
	return TRUE;
}

//---------------------------------------------------------------------------
//  MQCommandPlugin::OnMiddleButtonDown
//    {^ꂽƂɌĂяo܂B
//---------------------------------------------------------------------------
BOOL MQCommandPlugin::OnMiddleButtonDown(MQDocument doc, MQScene scene, MOUSE_BUTTON_STATE& state)
{
	// Ws߂FALSEԂ
	return FALSE;
}

//---------------------------------------------------------------------------
//  MQCommandPlugin::OnMiddleButtonMove
//    {^Ȃ}EXړƂɌĂяo܂B
//---------------------------------------------------------------------------
BOOL MQCommandPlugin::OnMiddleButtonMove(MQDocument doc, MQScene scene, MOUSE_BUTTON_STATE& state)
{
	// Ws߂FALSEԂ
	return FALSE;
}

//---------------------------------------------------------------------------
//  MQCommandPlugin::OnMiddleButtonUp
//    {^ꂽƂɌĂяo܂B
//---------------------------------------------------------------------------
BOOL MQCommandPlugin::OnMiddleButtonUp(MQDocument doc, MQScene scene, MOUSE_BUTTON_STATE& state)
{
	// Ws߂FALSEԂ
	return FALSE;
}

//---------------------------------------------------------------------------
//  MQCommandPlugin::OnRightButtonDown
//    E{^ꂽƂɌĂяo܂B
//---------------------------------------------------------------------------
BOOL MQCommandPlugin::OnRightButtonDown(MQDocument doc, MQScene scene, MOUSE_BUTTON_STATE& state)
{
	// Ws߂FALSEԂ
	return FALSE;
}

//---------------------------------------------------------------------------
//  MQCommandPlugin::OnRightButtonMove
//    E{^Ȃ}EXړƂɌĂяo܂B
//---------------------------------------------------------------------------
BOOL MQCommandPlugin::OnRightButtonMove(MQDocument doc, MQScene scene, MOUSE_BUTTON_STATE& state)
{
	// Ws߂FALSEԂ
	return FALSE;
}

//---------------------------------------------------------------------------
//  MQCommandPlugin::OnRightButtonUp
//    E{^ꂽƂɌĂяo܂B
//---------------------------------------------------------------------------
BOOL MQCommandPlugin::OnRightButtonUp(MQDocument doc, MQScene scene, MOUSE_BUTTON_STATE& state)
{
	// Ws߂FALSEԂ
	return FALSE;
}

//---------------------------------------------------------------------------
//  MQCommandPlugin::OnMouseMove
//    }EXړƂɌĂяo܂B
//---------------------------------------------------------------------------
BOOL MQCommandPlugin::OnMouseMove(MQDocument doc, MQScene scene, MOUSE_BUTTON_STATE& state)
{
	// Ws߂FALSEԂ
	return FALSE;
}

//---------------------------------------------------------------------------
//  MQCommandPlugin::OnMouseWheel
//    }EX̃zC[]ƂɌĂяo܂B
//    zC[̉]ʂstate.WheelWHEEL_DELTA̔{܂͖񐔂œ͂܂B
//---------------------------------------------------------------------------
BOOL MQCommandPlugin::OnMouseWheel(MQDocument doc, MQScene scene, MOUSE_BUTTON_STATE& state)
{
	// Ws߂FALSEԂ
	return FALSE;
}

//---------------------------------------------------------------------------
//  MQCommandPlugin::OnKeyDown
//    L[ꂽƂɌĂяo܂B
//---------------------------------------------------------------------------
BOOL MQCommandPlugin::OnKeyDown(MQDocument doc, MQScene scene, int key, MOUSE_BUTTON_STATE& state)
{
	// Ws߂FALSEԂ
	return FALSE;
}

//---------------------------------------------------------------------------
//  MQCommandPlugin::OnKeyUp
//    L[ꂽƂɌĂяo܂B
//---------------------------------------------------------------------------
BOOL MQCommandPlugin::OnKeyUp(MQDocument doc, MQScene scene, int key, MOUSE_BUTTON_STATE& state)
{
	// Ws߂FALSEԂ
	return FALSE;
}


// AhDobt@XV
void MQCommandPlugin::UpdateUndo()
{
	MQSendMessageInfo info;
	void *array[1];

	array[0] = NULL;

	GetPlugInID(&info.Product, &info.ID);
	info.option = array;

	MQ_SendMessage(MQMESSAGE_UPDATE_UNDO, &info);
}


// V[̍ĕ`\񂷂
void MQCommandPlugin::RedrawScene(MQScene scene)
{
	MQSendMessageInfo info;
	void *array[3];

	array[0] = "scene";
	array[1] = scene;
	array[2] = NULL;

	GetPlugInID(&info.Product, &info.ID);
	info.option = array;

	MQ_SendMessage(MQMESSAGE_REDRAW_SCENE, &info);
}

// ׂẴV[̍ĕ`\񂷂
void MQCommandPlugin::RedrawAllScene()
{
	MQSendMessageInfo info;
	void *array[1];

	array[0] = NULL;

	GetPlugInID(&info.Product, &info.ID);
	info.option = array;

	MQ_SendMessage(MQMESSAGE_REDRAW_ALL_SCENE, &info);
}

//---------------------------------------------------------------------------
//  MQCommandPlugin::GetEditOption
//    ҏWIvV擾
//---------------------------------------------------------------------------
void MQCommandPlugin::GetEditOption(EDIT_OPTION& option)
{
	MQSendMessageInfo info;
	void *array[27];

	memset(&option, 0, sizeof(EDIT_OPTION));
	
	array[0] = "edit_vertex";
	array[1] = &option.EditVertex;
	array[2] = "edit_line";
	array[3] = &option.EditLine;
	array[4] = "edit_face";
	array[5] = &option.EditFace;
	array[6] = "select_rect";
	array[7] = &option.SelectRect;
	array[8] = "select_rope";
	array[9] = &option.SelectRope;
	array[10] = "symmetry";
	array[11] = &option.Symmetry;
	array[12] = "symmetry_distance";
	array[13] = &option.SymmetryDistance;
	array[14] = "cur_obj_only";
	array[15] = &option.CurrentObjectOnly;
	array[16] = "snap_x";
	array[17] = &option.SnapX;
	array[18] = "snap_y";
	array[19] = &option.SnapY;
	array[20] = "snap_z";
	array[21] = &option.SnapZ;
	array[22] = "coordinate_type";
	array[23] = &option.CoordinateType;
	array[24] = "snap_grid";
	array[25] = &option.SnapGrid;
	array[26] = NULL;

	GetPlugInID(&info.Product, &info.ID);
	info.option = array;

	MQ_SendMessage(MQMESSAGE_GET_EDIT_OPTION, &info);
}

//---------------------------------------------------------------------------
//  MQCommandPlugin::GetSnappedPos
//    Xibvʒu擾
//---------------------------------------------------------------------------
MQPoint MQCommandPlugin::GetSnappedPos(MQScene scene, const MQPoint& p, SNAP_GRID_TYPE type)
{
	MQSendMessageInfo info;
	float pos[3], result[3];
	void *array[7];
	int itype = type;
	
	pos[0] = p.x;
	pos[1] = p.y;
	pos[2] = p.z;
	result[0] = result[1] = result[2] = 0;

	array[0] = "scene";
	array[1] = scene;
	array[2] = "type";
	array[3] = &itype;
	array[4] = "pos";
	array[5] = pos;
	array[6] = "result";
	array[7] = result;
	array[8] = NULL;

	GetPlugInID(&info.Product, &info.ID);
	info.option = array;

	MQ_SendMessage(MQMESSAGE_GET_SNAPPED_POS, &info);

	return MQPoint(result[0], result[1], result[2]);
}


//---------------------------------------------------------------------------
//  MQCommandPlugin::GetResourceCursor
//    W}EXJ[\擾
//---------------------------------------------------------------------------
HCURSOR MQCommandPlugin::GetResourceCursor(MQCURSOR_TYPE cursor_type)
{
	MQSendMessageInfo info;
	void *array[5];
	
	array[0] = "index";
	array[1] = &cursor_type;
	array[2] = "result";
	array[3] = NULL;
	array[4] = NULL;

	GetPlugInID(&info.Product, &info.ID);
	info.option = array;

	MQ_SendMessage(MQMESSAGE_GET_RESOURCE_CURSOR, &info);

	return (HCURSOR)array[3];
}

//---------------------------------------------------------------------------
//  MQCommandPlugin::SetMouseCursor
//    }EXJ[\ݒ
//
//    ݒ肷J[\GetResourceCursor()Ŏ擾̂A܂
//    Win32APILoadCursor()œDLL̃CX^Xێ
//    \[XJ[\w肵ĉB
//    LoadCursor()ŃCX^XNULLw肵ē`ς
//    J[\w肵͕̓ۏ؂܂B
//---------------------------------------------------------------------------
void MQCommandPlugin::SetMouseCursor(HCURSOR cursor)
{
	MQSendMessageInfo info;
	void *array[3];
	
	array[0] = "cursor";
	array[1] = cursor;
	array[2] = NULL;

	GetPlugInID(&info.Product, &info.ID);
	info.option = array;

	MQ_SendMessage(MQMESSAGE_SET_MOUSE_CURSOR, &info);
}


